(function($){

	$.fn.cloudly = function(customOptions){ //add the function
		var options = $.extend({}, $.fn.cloudly.defaultOptions, customOptions);
		return this.each(function(){ //loop over each element in the set and return them to keep the chain alive.
			var $this = $(this);
				
			/**************** OPTIONS **********************/
			var importantMin = options.impMin == "" ? options.tagMin*1.5 : options.impMin;
			var importantMax = options.impMax == "" ? options.tagMax*1.5 : options.impMax;
			var tagMin = options.tagMin;
			var tagMax = options.tagMax;
			var tagColor = [];
			var impColor = [];
			
			if(options.tagColor == 'rainbow'){
				tagColor = ['red', 'orange', 'yellow', 'green', 'blue', 'purple'];
			}else{
				tagColor = options.tagColor.split(',');
			}
			
			if(options.impColor == 'rainbow'){
				impColor = ['red', 'orange', 'yellow', 'green', 'blue', 'purple'];
			}else{
				impColor = options.impColor.split(',');
			}
			
			$this.find('.cloudly-tags a').each(function(){
				var important = $(this).hasClass('cloudly-important') ? true : false;
				var thisFontSize = important ? (Math.random()*(importantMax-importantMin+1))+importantMin : (Math.random()*(tagMax-tagMin+1))+tagMin;
				var thisColor = important ? impColor[Math.floor(Math.random()*impColor.length)] : tagColor[Math.floor(Math.random()*tagColor.length)];

				$(this).css({
					fontSize: thisFontSize,
					color: thisColor,
					textDecoration: options.underline ? 'underline' : 'none'
				});
				
			});
			
			$this.find('.cloudly-tags a').click(function(e){
				options.linked ? '' : e.preventDefault();
			});
				
		});
	};
		//options.blahblahblah
	//set default options
	$.fn.cloudly.defaultOptions = {
		tagMin: 12,
		tagMax: 21,
		impMin: "",
		impMax: "",
		tagColor: 'blue',
		impColor: 'blue',
		underline: false,
		linked: true
	};

})(jQuery);